<?php
/* =====================================================================
 * Dieses Skript ist Teil von "Wetter-Analyse in Dekaden (WADE)"
 * Von "Trixi aus Witten/NRW" - http://taw-wade.kilu.de/
 *                 Version 19.02.01 - Build 24.02.2019
 * Lizenziert unter "Namensnennung-Weitergabe unter gleichen Bedingungen
 * 3.0 Deutschland (CC BY-SA 3.0)"
 *                 ==> http://creativecommons.org/licenses/by-sa/3.0/de/
 *
 * Diese Software ist FREIE SOFTWARE und wird mit der Hoffnung, daß sie
 * nützlich sein könnte, zur Verfügung gestellt, jedoch OHNE JEDE
 * GEWÄHRLEISTUNG. Auch nicht für eine ALLGEMEINE GEBRAUCHSTAUGLICHKEIT
 * oder Stabilität für die NUTZUNG ZU EINEM BESTIMMTEN ZWECK. Die freie
 * Software, von der hier die Rede sein soll, ist kein "Freibier",
 * sondern sie gibt dir die Freiheiten
 *
 *   o  die Software für einen beliebigen Zweck auszuführen
 *   o  die Funktionsweise der Software zu studieren und sie an deine
 *      eigenen Bedürfnisse anzupassen
 *   o  Kopien der Software weiterzugeben
 *   o  sowie die Software zu verbessern und diese Verbesserungen zu
 *      veröffentlichen.
*/
// @module import "\t\tHolt die Wetter-Rohdaten einer Station und lädt\n\t\t\tsie in den lokalen Zwischenspeicher\n"
$DA->KonsolenAusgabe('Beginne mit der Ausführung von '.basename(__FILE__),1);
	if ( !is_dir($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher existiert nicht',-1);
	if ( !is_writable($einstellungen['zwischenspeicher']['speicher_pfad']) )
	$DA->KonsolenAusgabe('Das Verzeichnis für den Zwischenspeicher ist schreibgeschützt',-1);
	if ( strlen($DA->cli_parameter['station']) < 4 )
	$DA->KonsolenAusgabe('Es wurde keine Station mit "--station=[name]" angegeben',-1);
	if ( !isset($einstellungen['daten'][$DA->cli_parameter['station']]) )
	$DA->KonsolenAusgabe('Diese Station befindet sich nicht in der Konfiguration',-1);

$DA->KonsolenAusgabe('Importiere Daten der Station '.$DA->cli_parameter['station'],1);
$datum_reihe = array('17000101','20990101');
$jahre_in_datei = array();
$pruefsummen = array();
$socket_optionen_roh = array(
	'http'=>array(
		'protocol_version'=>1.1,
		'method'=>'GET',
		'header'=>"User-Agent: Wetter-Analyse in Dekaden/".WADE_VERSION_STRING." (http://taw-wade.kilu.de/)\r\n",
		),
	'ftp'=>array(
	)
);
	if ( $einstellungen['proxy']['http_benutzen'] && strlen($einstellungen['proxy']['http_hostname']) > 7 ){
	$socket_optionen_roh['http']['proxy'] = 'tcp://'.$einstellungen['proxy']['http_hostname'];
	$socket_optionen_roh['http']['request_fulluri'] = $einstellungen['proxy']['volle_uri_senden'];
	}
	if ( $einstellungen['proxy']['ftp_benutzen'] && strlen($einstellungen['proxy']['ftp_hostname']) > 7 )
	$socket_optionen_roh['ftp']['proxy'] = 'tcp://'.$einstellungen['proxy']['ftp_hostname'];

	foreach ( $einstellungen['daten'][$DA->cli_parameter['station']]['roh_daten'] as $id=>$datei ){
	$herunterladen = 0;
	$uuid = sprintf('%u',crc32($datei));
	$jahre_in_datei[$uuid] = ' ';
	$lokaler_pfad = $einstellungen['zwischenspeicher']['speicher_pfad'].'/'.$DA->cli_parameter['station'].'.'.$uuid;
	$socket_optionen = $socket_optionen_roh;
	$DA->KonsolenAusgabe('Bearbeite Roh-Datei #'.$id.' - '.basename($datei),2);
	$DA->KonsolenAusgabe('Lokaler Pfad ist '.$lokaler_pfad,3);
	$DA->KonsolenAusgabe('Entfernter Pfad ist '.$datei,3);
		if ( file_exists($lokaler_pfad) ){
		$DA->KonsolenAusgabe('Im Zwischenspeicher gefunden. Schaue nach, ob sie noch aktuell ist...',2);
		$DA->KonsolenAusgabe('Verwende Modul '.$einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren'].' für den Zugriff',3);
			switch ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren'] ){
			case 'ftp-dateigroesse':
			$context = stream_context_create($socket_optionen);
			$datei_groesse = filesize($datei); // filesize() kann (noch) keinen Kontext annehmen!
				if ( !$datei_groesse || $datei_groesse === 0 ){
				$DA->KonsolenAusgabe('Konnte keine Verbindung zum FTP-Server aufbauen',1);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,1);
				continue 2;
				}
			$DA->KonsolenAusgabe('filesize(cached_file): '.(int)filesize($lokaler_pfad),3);
			$DA->KonsolenAusgabe('filesize(remote_file): '.(int)$datei_groesse,3);
				if ( (int)$datei_groesse > (int)filesize($lokaler_pfad) ){
				$DA->KonsolenAusgabe('Neuere Version auf dem FTP-Server gefunden',2);
				$herunterladen = (int)$datei_groesse;
					if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] )
					unlink($lokaler_pfad);
				}
				else{
				$DA->KonsolenAusgabe('Der FTP-Server meldet sie als aktuell',2);
				$herunterladen = -1;
				}
			break;
			case 'http-get-dateigroesse':
			$context = stream_context_create($socket_optionen);
			$daten = file_get_contents($datei,false,$context,0,100);
				if ( !$daten || !isset($http_response_header) || strlen($http_response_header) < 200 ){
				$DA->KonsolenAusgabe('Konnte keine Verbindung zum HTTP-Server aufbauen',1);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,1);
				continue 2;
				}
			$header = implode("\r\n",$http_response_header);
			$DA->KonsolenAusgabe('filesize(cached_file): '.(int)filesize($lokaler_pfad),3);
			$DA->KonsolenAusgabe(print_r($header,true),3);
			preg_match('/^Content-Length: (\d+)/im',$header,$datei_groesse);
				if ( isset($datei_groesse[1]) && (int)$datei_groesse[1] > (int)filesize($lokaler_pfad) ){
				$DA->KonsolenAusgabe('Neuere Version auf dem HTTP-Server gefunden',2);
				$herunterladen = (int)$datei_groesse[1];
					if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] )
					unlink($lokaler_pfad);
				}
				else{
				$DA->KonsolenAusgabe('Der HTTP-Server meldet sie als aktuell',2);
				$herunterladen = -1;
				}
			break;
			case 'file-dateigroesse':
			$datei_groesse = filesize($datei);
				if ( !$datei_groesse ){
				$DA->KonsolenAusgabe('Konnte Datei in lokaler Quelle nicht finden',2);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,2);
				continue 2;
				}
			$DA->KonsolenAusgabe('filesize(cached_file): '.(int)filesize($lokaler_pfad),3);
				if ( (int)$datei_groesse > (int)filesize($lokaler_pfad) ){
				$DA->KonsolenAusgabe('Neuere Version in lokaler Datei gefunden',2);
				$herunterladen = (int)$datei_groesse;
					if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] )
					unlink($lokaler_pfad);
				}
				else{
				$DA->KonsolenAusgabe('Der lokale Quelle meldet sie als aktuell',2);
				$herunterladen = -1;
				}
			break;
			default: $herunterladen = -1; break;
			}
		}
		else
		$DA->KonsolenAusgabe('Nicht im Zwischenspeicher gefunden',2);

		if ( $herunterladen > -1 ){
			switch ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren'] ){
			case 'ftp-dateigroesse':
			$DA->KonsolenAusgabe('Lade Datei von der FTP-Quelle herunter',2);
				if ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] && file_exists($lokaler_pfad) ){
				$socket_optionen['ftp']['resume_pos'] = intval(filesize($lokaler_pfad)-1);
				$DA->KonsolenAusgabe('Fordere nur die neuen Daten (letzten '.intval($herunterladen-filesize($lokaler_pfad)).' Bytes) vom Server an',2);
				}
			$context = stream_context_create($socket_optionen);
			$daten = file_get_contents($datei,false,$context);
				if ( !$daten ){
				$DA->KonsolenAusgabe('Konnte keine Verbindung zum FTP-Server aufbauen',1);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,1);
				continue 2;
				}
				if ( $daten && strlen($daten) >= 1000 ){
					if ( isset($socket_optionen['ftp']['resume_pos']) ){
					$daten = $DA->file_put_contents_wrapper($lokaler_pfad,$daten,FILE_APPEND|LOCK_EX);
					$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher angehängt',2);
					}
					else{
					$daten = $DA->file_put_contents_wrapper($lokaler_pfad,$daten);
					$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher abgelegt',2);
					}
				}
				else
				$DA->KonsolenAusgabe('Es muß mindestens 1 Kilobyte nachgeladen werden',2);
			break;
			case 'http-get-dateigroesse':
			$DA->KonsolenAusgabe('Lade Datei von der HTTP-Quelle herunter',2);
				if ( $einstellungen['daten'][$DA->cli_parameter['station']]['aktualisieren_nur_neues'] && file_exists($lokaler_pfad) ){
				$socket_optionen['http']['header'] .= "Range: bytes=".intval(filesize($lokaler_pfad)-1)."-".($herunterladen)."\r\n";
				$DA->KonsolenAusgabe('Fordere nur die neuen Daten (letzten '.intval($herunterladen-filesize($lokaler_pfad)).' Bytes) vom Server an',2);
				}
			$context = stream_context_create($socket_optionen);
			$daten = file_get_contents($datei,false,$context);
				if ( !$daten || !isset($http_response_header) || strlen($http_response_header) < 200 ){
				$DA->KonsolenAusgabe('Konnte keine Verbindung zum HTTP-Server aufbauen',1);
				$DA->KonsolenAusgabe('Überspringe aktuelle Roh-Datei #'.$id,1);
				continue 2;
				}
			$header = implode("\r\n",$http_response_header);
			$DA->KonsolenAusgabe(print_r($header,true),3);
				if ( $daten && strlen($daten) >= 1000 ){
					if ( stripos($header,'206 partial content') ){
					$daten = $DA->file_put_contents_wrapper($lokaler_pfad,$daten,FILE_APPEND|LOCK_EX);
					$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher angehängt',2);
					}
					else{
					$daten = $DA->file_put_contents_wrapper($lokaler_pfad,$daten);
						if ( strpos($socket_optionen['http']['header'],'Range:') )
						$DA->KonsolenAusgabe('Server unterstützt kein teilweises herunterladen.',2);
					$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher abgelegt',2);
					}
				}
				else
				$DA->KonsolenAusgabe('Es muß mindestens 1 Kilobyte nachgeladen werden',2);
			break;
			case 'file-dateigroesse':
			$DA->KonsolenAusgabe('Lade Datei von der lokalen Quelle herunter',2);
			$daten = file_get_contents($datei);
				if ( $daten && strlen($daten) > 2048 ){
				$daten = $DA->file_put_contents_wrapper($lokaler_pfad,$daten);
				$DA->KonsolenAusgabe($daten.' Bytes geladen und im Zwischenspeicher abgelegt',2);
				}
			break;
			}
		}

		switch ( $einstellungen['daten'][$DA->cli_parameter['station']]['typus'] ){
		case 'dwd_kl2000':
			if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['datenformat_pruefen'] )
			break;
		$warnungen = 0;
		$neu_schreiben = false;
		$DA->KonsolenAusgabe('Überprüfe Integrität des Datenformats "dwd_kl2000"',2);

		$magische_bytes = file_get_contents($lokaler_pfad,false,null,0,3);
		$kompression_helfer = ( bin2hex($magische_bytes) === '1f8b08' ) ? 'compress.zlib://' : 'file://';
		$daten = ( file_exists($lokaler_pfad) ) ? file($kompression_helfer.$lokaler_pfad,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES) : array();
			if ( is_array($daten) && sizeof($daten) > 1 ){
			$DA->KonsolenAusgabe(sizeof($daten).' Datensätze in Roh-Datei gefunden',2);
				foreach ( $daten as $zeile=>$satz ){
					if ( strlen($satz) < 16 )
					continue;
					// DWD sendet ein für uns überflüssiges 0x1a ("SUB" -> ^Z) mit...
					if ( substr($satz,0,1) == chr(0x1a) ){
					$satz = substr($satz,1);
					$daten[$zeile] = $satz;
					$neu_schreiben = true;
					$DA->KonsolenAusgabe('Der Datensatz '.$zeile.' enthält ein ungültiges Zeichen und wurde korrigiert',2);
					}
					if ( strlen($satz) < 282 || !in_array(substr($satz,0,2),array('KF','KG','KK','KL','KX'),true) ){
						if ( $warnungen === 15 )
						$DA->KonsolenAusgabe('Weitere Warnungen für ungültige Zeilen werden unterdrückt',2);
						elseif ( $warnungen < 15 )
						$DA->KonsolenAusgabe('Der Datensatz '.$zeile.' enthält ein ungültiges Format und wurde entfernt',2);
					$neu_schreiben = true;
					$warnungen++;
					unset($daten[$zeile]);
					continue;
					}
				$datum = substr($satz,7,8);
					if ( $datum > $datum_reihe[0] )
					$datum_reihe[0] = $datum;
					if ( $datum < $datum_reihe[1] )
					$datum_reihe[1] = $datum;
				$jahr = substr($datum,0,4);
					if ( !strpos($jahre_in_datei[$uuid],$jahr.' ') )
					$jahre_in_datei[$uuid] .= $jahr.' ';
				}
			}
		break;
		case 'dwd_hist':
			if ( !$einstellungen['daten'][$DA->cli_parameter['station']]['datenformat_pruefen'] )
			break;
		$warnungen = 0;
		$neu_schreiben = false;
		$DA->KonsolenAusgabe('Überprüfe Integrität des Datenformats "dwd_hist"',2);

		$magische_bytes = file_get_contents($lokaler_pfad,false,null,0,3);
		$kompression_helfer = ( bin2hex($magische_bytes) === '1f8b08' ) ? 'compress.zlib://' : 'file://';
		$daten = ( file_exists($lokaler_pfad) ) ? file($kompression_helfer.$lokaler_pfad,FILE_IGNORE_NEW_LINES|FILE_SKIP_EMPTY_LINES) : array();
			if ( is_array($daten) && sizeof($daten) > 1 ){
			$DA->KonsolenAusgabe(sizeof($daten).' Datensätze in Roh-Datei gefunden',2);
				foreach ( $daten as $zeile=>$satz ){
					if ( strlen($satz) < 16 )
					continue;
					// DWD sendet ein für uns überflüssiges 0x1a ("SUB" -> ^Z) mit...
					if ( substr($satz,0,1) == chr(0x1a) ){
					$satz = substr($satz,1);
					$daten[$zeile] = $satz;
					$neu_schreiben = true;
					$DA->KonsolenAusgabe('Der Datensatz '.$zeile.' enthält ein ungültiges Zeichen und wurde korrigiert',2);
					}
					if ( strlen($satz) < 130 || strlen($satz) > 312 || substr($satz,-4) !== ',eor' ){
						if ( $warnungen === 15 )
						$DA->KonsolenAusgabe('Weitere Warnungen für ungültige Zeilen werden unterdrückt',2);
						elseif ( $warnungen < 15 )
						$DA->KonsolenAusgabe('Der Datensatz '.$zeile.' enthält ein ungültiges Format und wurde entfernt',2);
					$neu_schreiben = true;
					$warnungen++;
					unset($daten[$zeile]);
					continue;
					}
					if ( $zeile === 0 )
					continue;
				$datum = substr($satz,10,8);
					if ( $datum > $datum_reihe[0] )
					$datum_reihe[0] = $datum;
					if ( $datum < $datum_reihe[1] )
					$datum_reihe[1] = $datum;
				$jahr = substr($datum,0,4);
					if ( !strpos($jahre_in_datei[$uuid],$jahr.' ') )
					$jahre_in_datei[$uuid] .= $jahr.' ';
				}
			}
		break;
		}

		if ( $neu_schreiben ){
		$DA->KonsolenAusgabe('Die Roh-Datei wurde in einer korrigierten Fassung neu geschrieben',2);
			if ( $warnungen > 0 )
			$DA->KonsolenAusgabe('Es gab dabei insgesamt '.$warnungen.' Warnungen wegen fehlerhaften Formats',2);
		$DA->file_put_contents_wrapper($kompression_helfer.$lokaler_pfad,implode("\r\n",$daten));
		}

		if ( file_exists($lokaler_pfad) )
		$pruefsummen[$uuid] = sha1_file($lokaler_pfad);
	}

$manifest = "<?xml version='1.0' encoding='utf-8' standalone='yes'?>
<manifest>
	<station>".$DA->cli_parameter['station']."</station>
	<zeitreihe>".$datum_reihe[1]." ".$datum_reihe[0]."</zeitreihe>
	<letzte_aktualisierung>".date(DATE_ATOM,time())."</letzte_aktualisierung>
";
	foreach ( $pruefsummen as $datei=>$wert )
	$manifest .= chr(9).'<pruefsumme_'.$datei.'>'.$wert.'</pruefsumme_'.$datei.'>'.chr(10);
	foreach ( $jahre_in_datei as $datei=>$wert ){
	$wert = explode(' ',$wert);
		foreach ( $wert as $schluessel=>$wert2 ){
			if ( strlen($wert2) < 4 )
			unset($wert[$schluessel]);
		}
	$wert = array_unique($wert);
	sort($wert);
	$manifest .= chr(9).'<gefundene_jahre_'.$datei.'>'.trim(implode(',',$wert)).'</gefundene_jahre_'.$datei.'>'.chr(10);
	}
$manifest .= '</manifest>';
$DA->file_put_contents_wrapper(str_replace($uuid,'manifest',$lokaler_pfad),$manifest);

$DA->KonsolenAusgabe('Import abgeschlossen',1);
?>
